<?php
class Clientes extends Controller
{
    private $id_usuario;
    public function __construct()
    {
        parent::__construct();
        session_start();
        if (empty($_SESSION['activo'])) {
            header("location: " . base_url);
        }
        $this->id_usuario = $_SESSION['id_usuario'];
    }

    public function index()
    {
        $data['scripts'] = array(
            array('script' => 'moment.min.js'),         
            array('script' => 'chart.min.js'),            
            array('script' => 'pages/clientes.js'),
        );
        $this->views->getView('clientes', "index", $data);
    }

    public function dashboard($datos)
    {
        $data['idcliente']=$datos;
        $data['scripts'] = array(
            array('script' => 'moment.min.js'),         
            array('script' => 'chart.min.js'),           
            array('script' => 'pages/clientesreportes.js'),
        );
        $this->views->getView('clientes', "dashboard", $data);
    }

    

    public function comparacionVentasPagosMes($datos)
    {
        list($anio,$cliente)=explode(',', $datos);
        $desde = $anio . '-01-01';
        $hasta = $anio . '-12-31';

        $data['ventas'] = $this->model->comparacionVentasMes($desde, $hasta, $cliente);
        $data['pagos'] = $this->model->comparacionPagosMes($desde, $hasta, $cliente);
        echo json_encode($data);
        die();
    }

    public function comparacionVentasMes($datos)
    {
        list($anio,$cliente)=explode(',', $datos);
        $desde = $anio . '-01-01';
        $hasta = $anio . '-12-31';

        $data['ventas'] = $this->model->comparacionVentasMes($desde, $hasta, $cliente);
        echo json_encode($data);
        die();
    }

    public function comparacionPagosMes($datos)
    {
        list($anio,$cliente)=explode(',', $datos);
        $desde = $anio . '-01-01';
        $hasta = $anio . '-12-31';

        $data['pagos'] = $this->model->comparacionPagosMes($desde, $hasta, $cliente);
        echo json_encode($data);
        die();
    }

    public function listar()
    {
   
        $data = $this->model->getClientes($this->id_usuario);
        
        for ($i = 0; $i < count($data); $i++) {
            $data[$i]['editar'] = '';
            if ($data[$i]['estado'] == 1) {
                $data[$i]['editar'] = '<button class="btn btn-primary" type="button" onclick="btnEditarCli(' . $data[$i]['id'] . ');"><i class="fas fa-edit"></i></button>';
                $data[$i]['eliminar'] = '<button class="btn btn-danger" type="button" onclick="btnEliminarCli(' . $data[$i]['id'] . ');"><i class="fas fa-trash-alt"></i></button>';
                $data[$i]['estado'] = '<span class="badge badge-success">Activo</span>';
                $data[$i]['estado_txt'] = 'activo';
            } else {
                $data[$i]['eliminar'] = '<button class="btn btn-success" type="button" onclick="btnReingresarCli(' . $data[$i]['id'] . ');"><i class="fas fa-circle"></i></button>';
                $data[$i]['estado'] = '<span class="badge badge-danger">Inactivo</span>';
                $data[$i]['estado_txt'] = 'inactivo';
            }
        }
        echo json_encode($data, JSON_UNESCAPED_UNICODE);
        die();
    }

   
    public function editarAnotaciones()
    {
        $id = strClean($_POST['id']);
        $observaciones = $_POST['observaciones'];
        
        $data = $this->model->modificarAnotaciones($observaciones, $id);

        if ($data == "modificado") {
            $msg = array('msg' => 'Anotación modificada con exito', 'icono' => 'success');
        } else {
            $msg = array('msg' => 'Error al modificar la anotación', 'icono' => 'error');
        }

        echo json_encode($msg, JSON_UNESCAPED_UNICODE);
        die();
    }

    public function registrar()
    {
        $nombre = strClean($_POST['nombre']);
        $telefono = strClean($_POST['telefono']);
        $mensajeria = strClean($_POST['mensajeria']);
        $tipoid = strClean($_POST['tipoid']);                
        $nit = strClean($_POST['nit']);        
        $direccion = strClean($_POST['direccion']);
        $municipio = strClean($_POST['municipio']);
        $departamento = strClean($_POST['departamento']);
        $pais = strClean($_POST['pais']);
        $coordenadas = strClean($_POST['coordenadas']);

        $limite_credito = strClean($_POST['limite_credito']);
        $dias_credito = strClean($_POST['dias_credito']);
        $id_vendedor1 = strClean($_POST['id_vendedor1']);
        $id_sucursal1 = strClean($_POST['id_sucursal1']);        
        $tipocliente = strClean($_POST['tipocliente']);

        $contacto = strClean($_POST['contacto']);
        $telcontacto = strClean($_POST['telcontacto']);
        
        $observaciones = $_POST['observaciones'];


        $id = strClean($_POST['id']);
        if (empty($nombre) || empty($telefono) || empty($direccion)) {
            $msg = array('msg' => 'Todo los campos son obligatorios', 'icono' => 'error');
        } else {
            if ($id == "") {
                $data = $this->model->registrarCliente($nombre, $tipoid, $nit, $telefono, $mensajeria, $direccion, $municipio, $departamento, $pais, $coordenadas, $limite_credito, $dias_credito, $id_vendedor1, $id_sucursal1, $tipocliente, $contacto, $telcontacto, $observaciones);
                if ($data == "ok") {
                    $msg = array('msg' => 'Cliente registrado', 'icono' => 'success');
                } else if ($data == "existe") {
                    $msg = array('msg' => 'El cliente ya existe', 'icono' => 'warning');
                } else {
                    $msg = array('msg' => 'Error al registrar el cliente', 'icono' => 'error');
                }
            } else {
                $data = $this->model->modificarCliente($nombre, $tipoid, $nit, $telefono,$mensajeria, $direccion, $municipio, $departamento, $pais, $coordenadas, $limite_credito, $dias_credito, $id_vendedor1, $id_sucursal1, $tipocliente, $contacto, $telcontacto, $observaciones, $id);
                if ($data == "modificado") {
                    $msg = array('msg' => 'Cliente modificado con éxito', 'icono' => 'success');
                } else {
                    $msg = array('msg' => 'Error al modificar el cliente', 'icono' => 'error');
                }
            }
        }
        echo json_encode($msg, JSON_UNESCAPED_UNICODE);
        die();
    }

    public function insertar()
    {
        $data['vendedores']=$this->model->getVendedores();
        $data['sucursales']=$this->model->getSucursales();
        $data['paises']=$this->model->getPaises();
        echo json_encode($data, JSON_UNESCAPED_UNICODE);
        die();
    }

    public function editar(int $id)
    {
        $data = $this->model->editarCli($id);

        $data['vendedores']=$this->model->getVendedores();
        $data['sucursales']=$this->model->getSucursales();        
        $data['paises']=$this->model->getPaises();
        echo json_encode($data, JSON_UNESCAPED_UNICODE);
        die();
    }

    public function generarReporteEstadoCuenta($id)
    {
        $data['cliente'] = $this->model->editarCli($id);
        $data['empresa'] = $this->model->getEmpresa();
        $data['detalle'] = $this->model->getReporteEstadoCuenta($id);
        
        ob_start();
        $html = $this->views->getView('clientes', "reporteestadocuenta", $data);
        $html = ob_get_clean();
        require_once 'vendor/autoload.php';
        $mpdf = new \Mpdf\Mpdf();
        if ($data['compra']['estado'] == 0) {
            $mpdf->SetWatermarkImage('Assets/img/anulado.png');
            $mpdf->showWatermarkImage = true;
        }

        $mpdf = new \Mpdf\Mpdf([]);
        $mpdf->WriteHTML($html);
        $mpdf->Output();
    }
    
    public function generarReporteAntiguedadSaldos($id)
    {
        if((int)$id!==0) $data['cliente'] = $this->model->editarCli($id);
        $data['empresa'] = $this->model->getEmpresa();
        $data['detalle'] = $this->model->getReporteAntiguedadSaldos($id);

        ob_start();
        $html = $this->views->getView('clientes', "reporteantiguedadsaldos", $data);
        $html = ob_get_clean();
        require_once 'vendor/autoload.php';

        $mpdf = new \Mpdf\Mpdf([]);
        $mpdf->WriteHTML($html);
        $mpdf->Output('Antiguedad_saldos.pdf', 'I');
    }

    public function generarReporteCuentasCobrar($id)
    {
        if((int)$id!==0) $data['cliente'] = $this->model->editarCli($id);
        $data['empresa'] = $this->model->getEmpresa();
        $data['detalle'] = $this->model->getReporteCuentasCobrar($id);

        ob_start();
        $html = $this->views->getView('clientes', "reportecuentascobrar", $data);
        $html = ob_get_clean();
        require_once 'vendor/autoload.php';

        $mpdf = new \Mpdf\Mpdf([]);
        $mpdf->WriteHTML($html);
        $mpdf->Output('Cuentas_cobrar.pdf', 'I');
    }
       

    public function eliminar(int $id)
    {
        $data = $this->model->accionCli(0, $id);
        if ($data == 1) {
            $msg = array('msg' => 'Cliente dado de baja', 'icono' => 'success');
        } else {
            $msg = array('msg' => 'Error al eliminar el cliente', 'icono' => 'error');
        }
        echo json_encode($msg, JSON_UNESCAPED_UNICODE);
        die();
    }
    
    public function reingresar(int $id)
    {
        $data = $this->model->accionCli(1, $id);
        if ($data == 1) {
            $msg = array('msg' => 'Cliente reingresado', 'icono' => 'success');
        } else {
            $msg = array('msg' => 'Error al reingresar el cliente', 'icono' => 'error');
        }
        echo json_encode($msg, JSON_UNESCAPED_UNICODE);
        die();
    }

    public function buscarCliente()
    {
        $data = $this->model->buscarCliente($_GET['q']);
        $datos = array();
        foreach ($data as $row) {
            $data['id'] = $row['id'];
            $data['label'] = $row['nombre'] . ' - ' . $row['direccion'];
            $data['value'] = $row['nombre'];
            $data['vendedor'] = $row['id_vendedor1'];
            $data['tipoid'] = $row['tipoid'];
            $data['nit'] = $row['nit'];         
            $data['direccion'] = $row['direccion'];
            array_push($datos, $data);
        }
        echo json_encode($datos, JSON_UNESCAPED_UNICODE);
        die();
    }
}
