<?php
class ClientesModel extends Query{

    public function __construct()
    {
        parent::__construct();
    }

    public function getClientes(int $id_usuario)
    {
        if ($id_usuario<=100)
        {
            $sql = "SELECT *,DATEDIFF(now(),ultimaventa) as diasdiferencia FROM clientes";
        } else
        {
            $sql = "SELECT *,DATEDIFF(now(),ultimaventa) as diasdiferencia FROM clientes WHERE id_sucursal1 = $id_usuario";
        }

        //$sql = "SELECT *,DATE_FORMAT(ultimaventa,'%d/%m/%Y') as ultimaventa FROM clientes";
        $data = $this->selectAll($sql);
        return $data;
    }

    public function comparacionVentasMes(string $desde, string $hasta, int $idcliente)
    {
        $sql = "SELECT
            COALESCE(SUM(IF(MONTH(fecha) = 1,  total, 0)),0) AS ene,
            COALESCE(SUM(IF(MONTH(fecha) = 2,  total, 0)),0) AS feb,
            COALESCE(SUM(IF(MONTH(fecha) = 3,  total, 0)),0) AS mar,
            COALESCE(SUM(IF(MONTH(fecha) = 4,  total, 0)),0) AS abr,
            COALESCE(SUM(IF(MONTH(fecha) = 5,  total, 0)),0) AS may,
            COALESCE(SUM(IF(MONTH(fecha) = 6,  total, 0)),0) AS jun,
            COALESCE(SUM(IF(MONTH(fecha) = 7,  total, 0)),0) AS jul,
            COALESCE(SUM(IF(MONTH(fecha) = 8,  total, 0)),0) AS ago,
            COALESCE(SUM(IF(MONTH(fecha) = 9,  total, 0)),0) AS sep,
            COALESCE(SUM(IF(MONTH(fecha) = 10, total, 0)),0) AS oct,
            COALESCE(SUM(IF(MONTH(fecha) = 11, total, 0)),0) AS nov,
            COALESCE(SUM(IF(MONTH(fecha) = 12, total, 0)),0) AS dic
        FROM ventas
        WHERE fecha BETWEEN '$desde' AND '$hasta' AND id_cliente='$idcliente'";
        $data = $this->select($sql);
        return $data;
    }

    public function comparacionPagosMes(string $desde, string $hasta, int $idcliente)
    {
        $sql = "SELECT
            COALESCE(SUM(IF(MONTH(fecha_abono) = 1,  monto, 0)),0) AS ene,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 2,  monto, 0)),0) AS feb,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 3,  monto, 0)),0) AS mar,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 4,  monto, 0)),0) AS abr,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 5,  monto, 0)),0) AS may,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 6,  monto, 0)),0) AS jun,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 7,  monto, 0)),0) AS jul,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 8,  monto, 0)),0) AS ago,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 9,  monto, 0)),0) AS sep,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 10, monto, 0)),0) AS oct,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 11, monto, 0)),0) AS nov,
            COALESCE(SUM(IF(MONTH(fecha_abono) = 12, monto, 0)),0) AS dic
        FROM abonos
        WHERE fecha_abono BETWEEN '$desde' AND '$hasta' AND id_cliente='$idcliente'";

        $data = $this->select($sql);
        return $data;
    }

    public function getEmpresa()
    {
        $sql = "SELECT * FROM empresa";
        $data = $this->select($sql);
        return $data;
    }

    public function getVendedores()
    {
        $sql = "SELECT codven, nombre FROM vendedores";
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getSucursales()
    {
        $sql = "SELECT iduser, user FROM ws_users";
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getReporteCuentasCobrar($id)
    {
        if((int)$id!==0) {
            $sql = "SELECT
                    IFNULL((SELECT nombre FROM `clientes` WHERE clientes.id=creditos.cliente), 'MOSTRADOR') AS CLIENTE,
                    IF(cliente=0, 1, cliente) AS IDCLIENTE,            
                    venta as FACTURA,
                    fecha as FECHA,
                    monto as VALOR,
                    abonado as ABONO,
                    (monto - abonado) as SALDO,
                    DATEDIFF(NOW(), fecha) AS DIAS_DE_ATRASO
                    FROM `creditos`
                    WHERE cliente='".addslashes($id)."'
                    AND (monto - abonado) > 0
                    ORDER BY FACTURA ASC";
        } else {
            $sql = "SELECT 
                    IFNULL((SELECT nombre FROM `clientes` WHERE clientes.id=creditos.cliente), 'MOSTRADOR') AS CLIENTE,
                    IF(cliente=0, 1, cliente) AS IDCLIENTE,            
                    venta as FACTURA,
                    fecha as FECHA,
                    monto as VALOR,
                    abonado as ABONO,
                    (monto - abonado) as SALDO,
                    DATEDIFF(NOW(), fecha) AS DIAS_DE_ATRASO
                    FROM `creditos`
                    WHERE (monto - abonado) > 0
                    ORDER BY IDCLIENTE,FACTURA ASC";
        }
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getReporteAntiguedadSaldos($id)
    {
        if((int)$id!==0) {
            $sql = "SELECT 
                    IFNULL((SELECT nombre FROM `clientes` WHERE clientes.id=creditos.cliente), 'MOSTRADOR') AS CLIENTE,
                    IF(cliente=0, 1, cliente) AS IDCLIENTE,             
                    venta as FACTURA,
                    fecha as FECHA,
                    DATE_ADD(fecha, INTERVAL 30 DAY) as VENCE,
                    monto as VALOR,
                    abonado as ABONO,
                    (monto - abonado) as SALDO,
                    DATEDIFF(NOW(), fecha) AS DIAS_DE_ATRASO,
                    IF(DATEDIFF(NOW(), fecha)<=30, (monto - abonado), 0) as '30',
                    IF(DATEDIFF(NOW(), fecha)>30 && DATEDIFF(NOW(), fecha)<=60, (monto - abonado), 0) as '60',
                    IF(DATEDIFF(NOW(), fecha)>60, (monto - abonado), 0) as '90'
                    FROM `creditos`
                    WHERE cliente='".addslashes($id)."'
                    AND (monto - abonado) > 0
                    ORDER BY FACTURA ASC";
        } else {
            $sql = "SELECT 
                    IFNULL((SELECT nombre FROM `clientes` WHERE clientes.id=creditos.cliente), 'MOSTRADOR') AS CLIENTE,
                    IF(cliente=0, 1, cliente) AS IDCLIENTE,             
                    venta as FACTURA,
                    fecha as FECHA,
                    DATE_ADD(fecha, INTERVAL 30 DAY) as VENCE,
                    monto as VALOR,
                    abonado as ABONO,
                    (monto - abonado) as SALDO,
                    DATEDIFF(NOW(), fecha) AS DIAS_DE_ATRASO,
                    IF(DATEDIFF(NOW(), fecha)<=30, (monto - abonado), 0) as '30',
                    IF(DATEDIFF(NOW(), fecha)>30 && DATEDIFF(NOW(), fecha)<=60, (monto - abonado), 0) as '60',
                    IF(DATEDIFF(NOW(), fecha)>60, (monto - abonado), 0) as '90'
                    FROM `creditos`
                    WHERE (monto - abonado) > 0
                    ORDER BY IDCLIENTE,FACTURA ASC";
        }
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getReporteEstadoCuenta($id)
    {
        
        $sql = "(SELECT 
                venta as DOCUMENTO
                ,venta as ORDERDOCUMENTO
                ,fecha as FECHA
                ,monto as CARGO
                ,0 as ABONO
                ,'' as REFERENCIA
                FROM `creditos` WHERE cliente='".addslashes($id)."')
                UNION 
                (SELECT
                (SELECT concat(creditos.venta,' - R.',abonos.id) FROM `creditos` WHERE creditos.id=abonos.id_credito LIMIT 1) as DOCUMENTO
                ,(SELECT venta FROM `creditos` WHERE creditos.id=abonos.id_credito LIMIT 1) as ORDERDOCUMENTO
                ,fecha_abono as FECHA
                ,0 as CARGO
                ,monto * -1 as ABONO
                , CONCAT(metodo_pago,' | ',observaciones,' | ',referencias) as REFERENCIA
                FROM `abonos` WHERE id_cliente='".addslashes($id)."')
                ORDER BY ORDERDOCUMENTO, FECHA";
        /*$sql = "(SELECT 
                venta as DOCUMENTO
                ,fecha as FECHA
                ,monto as CARGO
                ,0 as ABONO
                ,'' as REFERENCIA
                FROM `creditos` WHERE cliente='".addslashes($id)."')
                UNION 
                (SELECT
                (SELECT venta FROM `creditos` WHERE creditos.id=abonos.id_credito LIMIT 1) as DOCUMENTO
                ,fecha_abono as FECHA
                ,0 as CARGO
                ,monto * -1 as ABONO
                , CONCAT(metodo_pago,' | ',observaciones,' | ',referencias) as REFERENCIA
                FROM `abonos` WHERE id_cliente='".addslashes($id)."')
                ORDER BY DOCUMENTO, FECHA";  */              
        $data = $this->selectAll($sql);
        return $data;
    }    


    

    public function getPaises()
    {
        $sql = "SELECT cod, pais FROM paises";
        $data = $this->selectAll($sql);
        return $data;
    }
    
    public function registrarCliente(string $nombre, int $tipoid,string $nit, string $telefono, string $mensajeria, string $direccion, string $municipio, string $departamento, string $pais, string $coordenadas, float $limite_credito, int $dias_credito, int $id_vendedor1, int $id_sucursal1,int $tipocliente, string $contacto, string $telcontacto, string $observaciones)
    {
        $verficar = "SELECT * FROM clientes WHERE nombre = '$nombre'";
        $existe = $this->select($verficar);
        if (empty($existe)) {
            $sql = "INSERT INTO clientes(nombre, tipoid, nit, telefono, mensajeria, direccion, municipio, departamento, pais, coordenadas, limite_credito, dias_credito, id_vendedor1, id_sucursal1, tipocliente ,contacto, telcontacto, observaciones) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            $datos = array($nombre, $tipoid, $nit, $telefono, $mensajeria, $direccion, $municipio, $departamento, $pais, $coordenadas, $limite_credito, $dias_credito, $id_vendedor1, $id_sucursal1, $tipocliente, $contacto, $telcontacto, $observaciones);
            $data = $this->save($sql, $datos);
            if ($data == 1) {
                $res = "ok";
            }else{
                $res = "error";
            }
        }else{
            $res = "existe";
        }
        return $res;
    }


    public function modificarCliente(string $nombre, int $tipoid, string $nit, string $telefono, string $mensajeria, string $direccion, string $municipio, string $departamento, string $pais, string $coordenadas, float $limite_credito, int $dias_credito, int $id_vendedor1, int $id_sucursal1, int $tipocliente, string $contacto, string $telcontacto, string $observaciones, int $id)
    {
        $sql = "UPDATE clientes SET nombre = ?, tipoid = ?, nit = ? ,telefono = ? ,mensajeria = ? ,direccion = ? ,municipio = ? ,departamento = ? ,pais = ? ,coordenadas = ? ,limite_credito = ? ,dias_credito = ?, id_vendedor1 = ?, id_sucursal1 = ?, tipocliente = ?, contacto = ?, telcontacto = ?, observaciones = ? WHERE id = ?";
        $datos = array($nombre, $tipoid, $nit, $telefono ,$mensajeria ,$direccion, $municipio, $departamento, $pais, $coordenadas, $limite_credito, $dias_credito, $id_vendedor1, $id_sucursal1, $tipocliente, $contacto, $telcontacto, $observaciones, $id);
        $data = $this->save($sql, $datos);
        if ($data == 1) {
            $res = "modificado";
        } else {
            $res = "error";
        }
        return $res;
    }

    public function modificarAnotaciones(string $observaciones, int $id)
    {
        $sql = "UPDATE clientes SET observaciones = ? WHERE id = ?";
        $datos = array($observaciones, $id);
        $data = $this->save($sql, $datos);
        if ($data == 1) {
            $res = "modificado";
        } else {
            $res = "error";
        }
        return $res;
    }

    public function editarCli(int $id)
    {
        $sql = "SELECT * FROM clientes WHERE id = $id";
        $data = $this->select($sql);
        return $data;
    }

    public function accionCli(int $estado, int $id)
    {
        $sql = "UPDATE clientes SET estado = ? WHERE id = ?";
        $datos = array($estado, $id);
        $data = $this->save($sql, $datos);
        return $data;
    }

    public function buscarCliente(string $nombre)
    {
        $sql = "SELECT * FROM clientes WHERE nombre LIKE '%" . $nombre . "%' AND estado = 1 LIMIT 10";
        $data = $this->selectAll($sql);
        return $data;
    }
}
