<?php
class CreditoventasModel extends Query
{
    public function __construct()
    {
        parent::__construct();
    }
    public function getCreditos(int $id_usuario)
    {
        //$sql = "SELECT c.nombre, cr.*, v.estado AS estatus FROM clientes c INNER JOIN creditos cr ON c.id = cr.cliente INNER JOIN ventas v ON cr.venta = v.id WHERE cr.id_usuario = $id_usuario";
        $sql = "SELECT c.nombre, cr.*, v.estado AS estatus FROM clientes c INNER JOIN creditos cr ON c.id = cr.cliente INNER JOIN ventas v ON cr.venta = v.id";        
        $data = $this->selectAll($sql);
        return $data;
    }
    public function getAbonos(int $id_usuario)
    {
        $sql = "SELECT c.nombre, a.* FROM clientes c INNER JOIN abonos a ON c.id = a.id_cliente WHERE a.id_usuario = $id_usuario";
        $data = $this->selectAll($sql);
        return $data;
    }
    public function datoAbono(int $id)
    {
        $sql = "SELECT c.nombre, c.telefono, a.*, cr.id, cr.monto AS total, cr.abonado, cr.restante FROM clientes c INNER JOIN abonos a ON c.id = a.id_cliente INNER JOIN creditos cr ON cr.id = a.id_credito WHERE a.id = $id";
        $data = $this->select($sql);
        return $data;
    }
    public function getEmpresa()
    {
        $sql = "SELECT * FROM empresa";
        $data = $this->select($sql);
        return $data;
    }
    public function registrarAbono(int $id_credito, int $id_cliente,string $monto, string $fecha, string $hora, int $id_usuario, string $fecha_abono, string $metodo, string $observaciones, string $referencias)
    {
        $sql = "INSERT INTO abonos(id_credito, id_cliente,monto, fecha, hora, id_usuario, metodo_pago, fecha_abono, observaciones, referencias ) VALUES (?,?,?,?,?,?, ?,?,?,?)";
        $datos = array($id_credito, $id_cliente,$monto, $fecha, $hora, $id_usuario,$metodo, $fecha_abono, $observaciones, $referencias);
        $data = $this->save($sql, $datos);
        
        $sql = "UPDATE clientes SET ultimopago=NOW() WHERE id = ?";
        $datos = array($id_cliente);
        $data2 = $this->save($sql, $datos);

        return $data;
    }

    public function getMetodos()
    {
        $sql = "SELECT codme, nombre FROM metodo_pago";
        $data = $this->selectAll($sql);
        return $data;
    }    

    public function getAbono(int $id)
    {
        $sql = "SELECT c.id AS id_cliente, c.nombre, cr.* 
        FROM clientes c INNER JOIN creditos cr ON c.id = cr.cliente WHERE cr.id = $id";
        $data = $this->select($sql);
        return $data;
    }
    public function actualizarCredito(string $table,string $monto, string $restante, int $id)
    {
        $sql = "UPDATE $table SET abonado = ?, restante = ? WHERE id = ?";
        $datos = array($monto, $restante,$id);
        $data = $this->save($sql, $datos);
        if ($data == 1) {
            $res = "ok";
        } else {
            $res = "error";
        }
        return $res;
    }
    public function estado(string $table,int $estado, int $id)
    {
        $sql = "UPDATE $table SET estado = ? WHERE id = ?";
        $datos = array($estado, $id);
        $data = $this->save($sql, $datos);
        if ($data == 1) {
            $res = "ok";
        } else {
            $res = "error";
        }
        return $res;
    }
    public function getCajaCierre(int $id)
    {
        $sql = "SELECT id, id_usuario, monto_inicial, estado FROM cajas_cierre WHERE id_usuario = $id AND estado = 1";
        $data = $this->select($sql);
        return $data;
    }
    public function detalleCredito(int $id)
    {
        $sql = "SELECT c.*, d.*, p.descripcion FROM creditos c INNER JOIN detalle_ventas d ON d.folio = c.venta INNER JOIN productos p ON d.id_producto = p.id WHERE c.id = $id";
        $data = $this->selectAll($sql);
        return $data;
    }
    public function detalleCliente(int $id)
    {
        $sql = "SELECT c.*, cl.id, cl.nombre, cl.telefono, cl.direccion, v.estado AS estatus FROM creditos c INNER JOIN clientes cl ON c.cliente = cl.id INNER JOIN ventas v ON c.venta = v.id WHERE c.id = $id";
        $data = $this->select($sql);
        return $data;
    }
    public function detalleAbono(int $id)
    {
        $sql = "SELECT a.monto AS abono, a.fecha, c.*, cl.nombre FROM abonos a INNER JOIN creditos c ON a.id_credito = c.id INNER JOIN clientes cl ON a.id_cliente = cl.id WHERE a.id_credito = $id";
        $data = $this->selectAll($sql);
        return $data;
    }
    public function estadoVenta(int $id)
    {
        $sql = "SELECT cr.venta FROM ventas v INNER JOIN creditos cr ON v.id = cr.venta WHERE cr.id = $id";
        $data = $this->select($sql);
        return $data;
    }
}
