<?php
class ProductosModel extends Query{
    public function __construct()
    {
        parent::__construct();
    }
    public function getProductos()
    {
        /*$sql = "
        SELECT ma.marca, c.categoria, me.medida, p.* FROM productos p 
        INNER JOIN marcas ma ON ma.id = p.id_marca 
        INNER JOIN categorias c ON c.id = p.id_categoria 
        INNER JOIN medidas me ON me.id = p.id_medida";
        */
        /*$sql = "SELECT 
        IFNULL( (SELECT marca FROM marcas ma WHERE ma.id = p.id_marca) , 'SIN MARCA') as marca
        ,IFNULL( (SELECT categoria FROM categorias ca WHERE ca.id = p.id_categoria) , 'SIN CATEGORIA') as categoria
        ,IFNULL( (SELECT medida FROM medidas me WHERE me.id = p.id_medida) , 'SIN MEDIDA') as medida
        ,DATEDIFF(now(),p.ultimaventa) as diasdiferencia,p.* FROM productos p";*/

        $sql = "SELECT 
        IFNULL( (SELECT marca FROM marcas ma WHERE ma.id = p.id_marca) , 'SIN MARCA') as marca
        ,foto
        ,codigo
        ,descripcion
        ,detalles
        ,precio_venta
        ,cantidad
        ,estado
        ,stock_minimo
        ,ultimaventa
        ,DATEDIFF(now(),p.ultimaventa) as diasdiferencia
        FROM productos p " ;        

        $data = $this->selectAll($sql);
        return $data;
    }

    public function getDatos(string $table)
    {
        $sql = "SELECT * FROM $table WHERE estado = 1";
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getSucursales()
    {
        $sql = "SELECT iduser as id, user as sucursal FROM ws_users";
        $data = $this->selectAll($sql);
        return $data;
    }

    public function registrarProductoMultiple($id,$precios)
    {
        $values='';

        $sql = "DELETE FROM `productos_detalle` WHERE `idproducto`= {$id}";
        $data = $this->save($sql, []);

        if(is_array($precios))
        {
            foreach ($precios as $key => $value) {
                $values.=(($values!=='')?',':'')."({$id},{$value},{$key}) ";
            }
            $sql = "INSERT INTO `productos_detalle`(`idproducto`, `precio`, `sucursal`) VALUES {$values} ";
            $data = $this->save($sql, []);            
        }

        return $data;
    }

    public function actualizarProductoMultiple($id,$precios)
    {
        $values='';

        if(is_array($precios))
        {
            foreach ($precios as $key => $value) {
                $sql = "UPDATE `productos_detalle` SET `precio`={$value} WHERE `idproducto`={$id} AND `sucursal`={$key} ";
                $data = $this->save($sql, []);                
            }

        }
        return;
    }    


    //public function registrarProducto(string $codigo, string $nombre, string $precio_compra, string $precio_venta, int $minimo, int $medidas, int $categorias, int $marcas, string $img)
    public function registrarProducto(
        string $codigo,
        string $img,
        string $ubicacion,
        string $observaciones,
        string $minimo,
        string $maximo,
        string $estado,
        string $imprime,
        string $codigo_alter,
        string $codigo_proveedor,
        string $descripcion,
        string $detalles,
        string $clasificacion,
        string $tipo,
        string $proveedor,
        string $medidas,
        string $categorias,
        string $marcas,
        array  $precios
    )
    {
        $verificar = "SELECT * FROM productos WHERE codigo = '$codigo'";
        $existe = $this->select($verificar);
        if (empty($existe)) {
            $sql = "INSERT INTO productos(
                codigo, 
                foto, 
                ubicacion,
                observaciones,
                stock_minimo,
                stock_maximo,
                estado,
                imprime,
                codigo_alter,
                codigo_proveedor,
                descripcion,
                detalles,
                clasificacion,
                tipo,
                id_proveedor,
                id_medida,
                id_categoria,
                id_marca
                ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            $datos = array(
                $codigo,
                $img,
                $ubicacion,
                $observaciones,
                $minimo,
                $maximo,
                $estado,
                $imprime,
                $codigo_alter,
                $codigo_proveedor,
                $descripcion,
                $detalles,
                $clasificacion,
                ($tipo=='')?NULL:$tipo,
                ($proveedor=='')?NULL:$proveedor,
                ($medidas=='')?NULL:$medidas,
                ($categorias=='')?NULL:$categorias,
                ($marcas=='')?NULL:$marcas           
            );
            //$data = $this->save($sql, $datos);
            $data = $this->insertar($sql, $datos);
            //if ($data == 1) {
            if ($data > 0) {
                $this->registrarProductoMultiple($data,$precios);
                $res= $data;
                $res = "ok";
            }else{
                $res = "error";
            }
        }else{
            $res = "existe";
        }
        return $res;
    }
    public function modificarProducto(
        string $codigo,
        string $img,
        int $id,
        string $ubicacion,
        string $observaciones,
        string $minimo,
        string $maximo,
        string $estado,
        string $imprime,
        string $codigo_alter,
        string $codigo_proveedor,
        string $descripcion,
        string $detalles,
        string $clasificacion,
        string $tipo,
        string $proveedor,
        string $medidas,
        string $categorias,
        string $marcas,
        array  $precios
    )
    {
        $verificar = "SELECT * FROM productos WHERE codigo = '$codigo' AND id != $id";
        $existe = $this->select($verificar);
        if (empty($existe)) {
            $sql = "UPDATE productos SET 
                codigo=?, 
                foto=?, 
                ubicacion=?,
                observaciones=?,
                stock_minimo=?,
                stock_maximo=?,
                estado=?,
                imprime=?,
                codigo_alter=?,
                codigo_proveedor=?,
                descripcion=?,
                detalles=?,
                clasificacion=?,
                tipo=?,
                id_proveedor=?,
                id_medida=?,
                id_categoria=?,
                id_marca=?         
                WHERE id = ?";
            $datos = array(
                $codigo,
                $img,
                $ubicacion,
                $observaciones,
                $minimo,
                $maximo,
                $estado,
                $imprime,
                $codigo_alter,
                $codigo_proveedor,
                $descripcion,
                $detalles,
                $clasificacion,
                ($tipo=='')?NULL:$tipo,
                ($proveedor=='')?NULL:$proveedor,
                ($medidas=='')?NULL:$medidas,
                ($categorias=='')?NULL:$categorias,
                ($marcas=='')?NULL:$marcas,
                $id
            );
            $data = $this->save($sql, $datos);
            if ($data == 1) {
                $this->actualizarProductoMultiple($id,$precios);
                $res = "modificado";
            } else {
                $res = "error";
            }
        }else{
            $res = "existe";
        }
        return $res;
    }
    public function editarPro(int $id)
    {
        $sql = "SELECT * FROM productos WHERE id = $id";
        $data = $this->select($sql);

        $sql = "SELECT * FROM productos_detalle WHERE idproducto = $id";
        $data['precios'] = $this->selectAll($sql);        

        return $data;
    }
    public function accionPro(int $estado, int $id)
    {
        $sql = "UPDATE productos SET estado = ? WHERE id = ?";
        $datos = array($estado, $id);
        $data = $this->save($sql, $datos);
        return $data;
    }
    public function getEmpresa()
    {
        $sql = "SELECT * FROM empresa";
        $data = $this->select($sql);
        return $data;
    }
    public function getProductosReporte()
    {
        //$sql = "SELECT ma.marca, c.categoria, me.medida, p.* FROM productos p INNER JOIN marcas ma ON ma.id = p.id_marca INNER JOIN categorias c ON c.id = p.id_categoria INNER JOIN medidas me ON me.id = p.id_medida WHERE p.estado = 1";
        $sql = "SELECT 
        IFNULL( (SELECT marca FROM marcas ma WHERE ma.id = p.id_marca) , 'SIN MARCA') as marca
        ,IFNULL( (SELECT categoria FROM categorias ca WHERE ca.id = p.id_categoria) , 'SIN CATEGORIA') as categoria
        ,IFNULL( (SELECT medida FROM medidas me WHERE me.id = p.id_medida) , 'SIN MEDIDA') as medida
        ,p.* FROM productos p";        
        $data = $this->selectAll($sql);
        return $data;
    }

    public function getProductosKardex($id)
    {
        //$sql = "SELECT ma.marca, c.categoria, me.medida, p.* FROM productos p INNER JOIN marcas ma ON ma.id = p.id_marca INNER JOIN categorias c ON c.id = p.id_categoria INNER JOIN medidas me ON me.id = p.id_medida WHERE p.estado = 1";
        $sql = "(SELECT 
                `compras`.`fecha` as FECHA,
                `compras`.`hora` as HORA,
                'COMPRA' as TIPO,
                `compras`.`id_proveedor` as IDREFERENCIA,
                (SELECT `proveedor`.`nombre` FROM `proveedor` WHERE `compras`.`id_proveedor`=`proveedor`.`id`) as REFERENCIA,
                `compras`.`id` as DOCUMENTO,
                `detalle_compra`.`cantidad` as CANTIDAD
                FROM `detalle_compra`,`compras` WHERE `detalle_compra`.`folio`=`compras`.`id` AND `detalle_compra`.`id_producto`='{$id}')
                UNION
                (SELECT 
                `ventas`.`fecha` as FECHA,
                `ventas`.`hora` as HORA,
                'VENTA' as TIPO,
                `ventas`.`id_cliente` as IDREFERENCIA,
                `ventas`.`nomcliente` as REFERENCIA,
                `ventas`.`id` as DOCUMENTO,
                `detalle_ventas`.`cantidad` as CANTIDAD
                FROM `detalle_ventas`,`ventas` WHERE `detalle_ventas`.`folio`=`ventas`.`id` AND `detalle_ventas`.`id_producto`='{$id}' AND `ventas`.`estado`!=0)
                ORDER BY FECHA, HORA";        
        $data = $this->selectAll($sql);
        return $data;
    }    
}
